﻿Imports MindFusion.RealTimeCharting.Wpf
Imports System.Windows.Threading

Class Window1

    Dim dispatcherTimer As Windows.Threading.DispatcherTimer
    Dim Tmr As New Stopwatch()
    Dim rand As Random
    Dim clusterSize As Integer = 1
    Dim currCount As Integer = 0
    Dim y1 As Double = 100, y2 As Double = 100, y3 As Double = 0.2
    ' y# are filtered, randomly-varying values
    Dim PPS As Double = 0
    'points per second
    Dim series1 As Series = Nothing
    Dim series2 As Series = Nothing
    Dim series3 As Series = Nothing

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        chart1.FrameLeftThickness = 50
        chart1.FrameRightThickness = 100
        chart1.FrameTopThickness = 100
        chart1.FrameBottomThickness = 100
        chart1.FastScrollMode = True

        chart1.TooltipVisibility = Visibility.Visible
        chart1.ShowFallbackTooltip = True

        chart1.LegendOrientation = System.Windows.Controls.Orientation.Horizontal
        chart1.LegendWidth = Double.NaN
        chart1.LegendHeight = 30
        chart1.ShowLegend = True

        chart1.MajorGridSizeY = 50
        chart1.MajorGridSizeX = 25
        chart1.MinorGridSizeX = 5

        chart1.XAxis.Title = "Time"
        chart1.XAxis.PinLabels = False

        Dim yAxis As New Axis()
        yAxis.Origin = -2000
        yAxis.Length = 7000
        yAxis.Interval = 500
        yAxis.Title = "Server1"
        yAxis.TitleRotationAngle = -90.0
        yAxis.TitleFontFamily = New FontFamily("Verdana")
        yAxis.LabelFontFamily = New FontFamily("Verdana")
        yAxis.TickLength = 5
        yAxis.TitleOffset = 10
        chart1.YAxisCollection.Add(yAxis)

        yAxis = New Axis()
        yAxis.Origin = -20
        yAxis.Length = 140
        yAxis.Interval = 10
        yAxis.Title = "Server2"
        yAxis.TitleRotationAngle = -90.0
        yAxis.TitleFontFamily = New FontFamily("Verdana")
        yAxis.LabelFontFamily = New FontFamily("Verdana")
        yAxis.TickLength = 5
        yAxis.TitleOffset = 10
        chart1.YAxisCollection.Add(yAxis)

        yAxis = New Axis()
        yAxis.Origin = -1
        yAxis.Length = 2.8
        yAxis.Interval = 0.2
        yAxis.Title = "Server3"
        yAxis.TitleRotationAngle = -90.0
        yAxis.TitleFontFamily = New FontFamily("Verdana")
        yAxis.LabelFontFamily = New FontFamily("Verdana")
        yAxis.TickLength = 5
        yAxis.TitleOffset = 10
        chart1.YAxisCollection.Add(yAxis)

        yAxis = New Axis()
        yAxis.Origin = 100
        yAxis.Length = 1400
        yAxis.Interval = 100
        yAxis.Title = "Megabytes served"
        yAxis.TitleRotationAngle = -90.0
        yAxis.TitleFontFamily = New FontFamily("Verdana")
        yAxis.LabelFontFamily = New FontFamily("Verdana")
        yAxis.TickLength = 5
        yAxis.TitleOffset = 10
        yAxis.LabelHorizontalAlignment = HorizontalAlignment.Right
        chart1.Y2AxisCollection.Add(yAxis)

        chart1.XAxis.LabelFontFamily = New FontFamily("Verdana")
        chart1.XAxis.TitleFontFamily = New FontFamily("Verdana")


        series1 = New Series(chart1.YAxisCollection(0)) With { _
          .Stroke = New SolidColorBrush(Color.FromRgb(166, 46, 68)), _
          .Title = "Server 1", _
          .ScatterType = ScatterType.None, _
          .TitleFontFamily = New FontFamily("Verdana"), _
          .TitleFontSize = 12 _
        }
        series2 = New Series(chart1.YAxisCollection(1)) With { _
          .Stroke = New SolidColorBrush(Color.FromRgb(9, 74, 10)), _
          .Fill = Brushes.Green, _
          .Title = "Server 2", _
          .ScatterType = ScatterType.None, _
          .TitleFontFamily = New FontFamily("Verdana"), _
          .TitleFontSize = 12 _
        }
        'blue
        series3 = New Series(chart1.YAxisCollection(2)) With { _
          .Stroke = New SolidColorBrush(Color.FromRgb(40, 75, 89)), _
          .Fill = Brushes.Blue, _
          .Title = "Server 3", _
          .ScatterType = ScatterType.None, _
          .TitleFontFamily = New FontFamily("Verdana"), _
          .TitleFontSize = 12 _
        }


        chart1.SeriesCollection.Add(series1)
        chart1.SeriesCollection.Add(series2)
        chart1.SeriesCollection.Add(series3)

        chart1.TooltipAxis = chart1.YAxisCollection(0)

        rand = New Random(CInt(DateTime.Now.Millisecond))
    End Sub

    Private Sub dispatcherTimer_Tick(ByVal sender As Object, ByVal e As EventArgs)
        chart1.FastScrollMode = True
        Dim points1 As Point() = New Point(clusterSize - 1) {}
        Dim points2 As Point() = New Point(clusterSize - 1) {}
        Dim points3 As Point() = New Point(clusterSize - 1) {}

        Dim minNewX As Double = currCount - 20

        For i As Integer = 0 To clusterSize - 1
            y1 = y1 * 0.93 + (rand.NextDouble() * 366) * 0.9
            y2 = y2 * 0.4 + (rand.NextDouble() * 66) * 0.08
            y3 = y3 * 0.6 + (rand.NextDouble() * 1.3) * 0.1

            points1(i) = New Point(currCount + i - 20, y1 - 66)
            '+ 066
            points2(i) = New Point(currCount + i - 10, y2 - 4)
            points3(i) = New Point(currCount + i - 0, y3 - 0.1)
        Next

        currCount += clusterSize
        PPS = 1000.0 * currCount / Tmr.ElapsedMilliseconds
        lblPoints.Content = (3 * currCount).ToString()
        '  TB_Rate.Text = "Points per second: " + PPS.ToString("#,0.0#");

        series1.Data.AddRange(points1)
        series2.Data.AddRange(points2)
        series3.Data.AddRange(points3)

        chart1.Commit(minNewX)

        DisposeOldData(series1)
        DisposeOldData(series2)
        DisposeOldData(series3)
    End Sub

    Private Sub DisposeOldData(ByVal series As Series)
        If series.Data.Count > 100 AndAlso series.Data(99).X < chart1.XAxis.Origin Then
            series.Data.RemoveRange(0, 100)
        End If
    End Sub

    Private Sub Window_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
        '  DispatcherTimer setup
        dispatcherTimer = New System.Windows.Threading.DispatcherTimer(DispatcherPriority.Send)
        AddHandler dispatcherTimer.Tick, AddressOf dispatcherTimer_Tick
        'dispatcherTimer.Tick += New EventHandler(dispatcherTimer_Tick)
        dispatcherTimer.Interval = TimeSpan.FromMilliseconds(40)
        dispatcherTimer.Start()
    End Sub

    Private Sub cbPinLabels_Checked(ByVal sender As Object, ByVal e As RoutedEventArgs)
        If chart1 IsNot Nothing Then
            If cbPinLabels.IsChecked.Value Then
                chart1.XAxis.PinLabels = True
            Else
                chart1.XAxis.PinLabels = False
            End If
        End If
    End Sub

    Private Sub sldrSpeed_ValueChanged(ByVal sender As Object, ByVal e As RoutedPropertyChangedEventArgs(Of Double))
        clusterSize = CInt(sldrSpeed.Value)
    End Sub

    Private Sub RadioButton_Checked(ByVal sender As Object, ByVal e As RoutedEventArgs)
        If chart1 Is Nothing Then
            Return
        End If
        If rb_server1.IsChecked.Value Then
            chart1.TooltipAxis = chart1.YAxisCollection(0)
        ElseIf rb_server2.IsChecked.Value Then
            chart1.TooltipAxis = chart1.YAxisCollection(1)
        Else
            chart1.TooltipAxis = chart1.YAxisCollection(2)
        End If
    End Sub

    Private Sub CheckBox_Checked(ByVal sender As Object, ByVal e As RoutedEventArgs)

        Dim box As CheckBox = CType(sender, CheckBox)
        If box Is cbScatter1 Then
            series1.ScatterType = ScatterType.Diamond
        ElseIf box Is cbScatter2 Then
            series2.ScatterType = ScatterType.Square
        Else
            series3.ScatterType = ScatterType.Triangle
        End If
    End Sub

    Private Sub CheckBox_Unchecked(ByVal sender As Object, ByVal e As RoutedEventArgs)
        If sender Is cbScatter1 Then
            series1.ScatterType = ScatterType.None
        ElseIf sender Is cbScatter2 Then
            series2.ScatterType = ScatterType.None
        Else
            series3.ScatterType = ScatterType.None
        End If
    End Sub
End Class
